#include <3067F.H>
#include "w6v5c.h"

/*mode=0x0_ : Z^[n_*/
/*mode=0x0_ : Z^[n_*/
/*mode=0x_1 : Ox		@PWOxɃXL*/
/*mode=0x_2 : PWOx@@@@OxɃXL*/

unsigned char scan_PSD0(unsigned char mode, unsigned char raw_data[2][91], unsigned char dir_v)
{
unsigned char	i, k;

	/**/
	if(mode == 0x01) move_head(  0, dir_v, 90, 40);
	if(mode == 0x02) move_head(180, dir_v, 90, 40);

	/*̓슮҂*/
	do{
		wait(100);
		i = check_status_servo();
	}while(i == 1);

	move_head2(180, dir_v, 90, 126);
	for(i = 0; i < 91; i++)
	{
		/*PSD*/
		raw_data[0][i] = read_PSD3();
		/*Compass*/
		raw_data[1][i] = P5DR.BYTE & 7;
		/*wait(142);*/
		wait(28);
	}

	do{
		wait(100);
		k = check_status_servo();
	}while(k == 1);

	/*ɖ߂*/
	move_head( 90, 90, 90, 40);
	/*̓슮҂*/
	do{
		wait(100);
		k = check_status_servo();
	}while(k == 1);

	return(0);
}

/*p^[݂̏ȓPSDƒgZT̃XLs*/
/*mode=0x0_ : Z^[n_*/
/*mode=0x0_ : Z^[n_*/
/*mode=0x_1 : Ox		@PWOxɃXL*/
/*mode=0x_2 : PWOx@@@@OxɃXL*/

unsigned char scan0(unsigned char mode, unsigned char psd_data[32], 
					unsigned int sonic_data[32])
{
unsigned char	i, j, k, dir_v;

	dir_v = 90;

	/**/
	if(mode == 0x01) move_head(  0, dir_v, 90, 40);
	if(mode == 0x02) move_head(180, dir_v, 90, 40);

	/*̓슮҂*/
	do{
		wait(100);
		i = check_status_servo();
	}while(i == 1);

	/*XLJn*/
	j = 0;
	for(i = 0; i < 19; i++)
	{
		psd_data[i] = read_PSD3();
		sonic_data[i] = read_sonic2();

		move_head2(j, dir_v, 90, 10);
		do{
			wait(100);
			k = check_status_servo();
		}while(k == 1);
		j = j + 10;
	}


	/*ɖ߂*/
	move_head( 90, 90, 90, 40);
	/*̓슮҂*/
	do{
		wait(100);
		k = check_status_servo();
	}while(k == 1);

	return(0);
}
/*********************************************************************************/
/*RUOxXL*/
/*p^[L݂̏ȓPSDAgZTĂb̃XLs*/
/*********************************************************************************/
unsigned char scan1(unsigned char psd_data[64], unsigned int sonic_data[64],
					unsigned char brightness[64])
{
unsigned char	i, j, k, dir_v;

	dir_v = 90;

	/**/
	move_head(0, dir_v, 0, 90);

	/*̓슮҂*/
	do{
		wait(100);
		i = check_status_servo();
	}while(i == 1);

	j = 0;
	for(i = 0; i < 19; i++)
	{
		psd_data[i] = read_PSD3();
		sonic_data[i] = read_sonic2();
		brightness[i] = read_cds();

		move_head(j, dir_v, 0, 12);
		do{
			wait(100);
			k = check_status_servo();
		}while(k == 1);
		j = j + 10;
	}

	/**/
	move_head(0, dir_v, 180, 140);

	/*̓슮҂*/
	do{
		wait(100);
		i = check_status_servo();
	}while(i == 1);

	j = 10;
	for(i = 19; i < 37; i++)
	{
		psd_data[i] = read_PSD3();
		sonic_data[i] = read_sonic2();
		brightness[i] = read_cds();

		move_head(j, dir_v, 180, 12);
		do{
			wait(100);
			k = check_status_servo();
		}while(k == 1);
		j = j + 10;
	}

	/*ɖ߂*/
	move_head( 90, 90, 90, 90);
	/*̓슮҂*/
	do{
		wait(100);
		k = check_status_servo();
	}while(k == 1);

	return(0);
}


/*********************************************************************************/
/*  ܂͍𓮂Ď͂̃XLs*/
/*********************************************************************************/
unsigned char scan2(struct SCAN *scan)
{
unsigned char	i, start_dir, end_dir, data_num;
int				ii;
float			time_f;

	start_dir = 90 - scan->scope;
	end_dir = 90 + scan->scope;

	/*i = scan->scope / 2;*//*쓮*/
	i = 45;

	/*𓮂ăXLij*/
	if(scan->mode == '1')
	{
		/*Jn*/
		move_head(start_dir, scan->dir_v, scan->dir_body, i);
		wait_servo();

		/*
		*/
		time_f = (float)126.0 / (float)180.0 * (float)scan->scope * (float)2.0;
		ii = (int)time_f;
		i = (unsigned char)ii;

		move_head2(end_dir, scan->dir_v, scan->dir_body, i);
		data_num = scan->scope + 1;
		for(i = 0; i < data_num; i++)
		{
			scan->psd_data[i] = read_PSD3();
			scan->sonic_data[i] = read_sonic2();
			scan->cds_data[i] = read_cds();
			wait(28);
		}
	}

	/*̂𓮂ăXLij*/
	if(scan->mode == '2')
	{
		/*Jn*/
		move_head(scan->dir_head, scan->dir_v, start_dir, i);
		wait_servo();

		/*
		*/
		time_f = (float)126.0 / (float)180.0 * (float)scan->scope * (float)2.0;
		ii = (int)time_f;
		i = (unsigned char)ii;

		move_head2(scan->dir_head, scan->dir_v, end_dir, i);
		data_num = scan->scope + 1;
		for(i = 0; i < data_num; i++)
		{
			scan->psd_data[i] = read_PSD3();
			scan->sonic_data[i] = read_sonic2();
			scan->cds_data[i] = read_cds();
			wait(28);
		}
	}

	/*𓮂ăXLij*/
	if(scan->mode == '3')
	{
		/*Jn*/
		move_head(scan->dir_head, start_dir, scan->dir_body, i);
		wait_servo();

		/*
		*/
		time_f = (float)126.0 / (float)180.0 * (float)scan->scope * (float)2.0;
		ii = (int)time_f;
		i = (unsigned char)ii;

		move_head2(scan->dir_head, end_dir, scan->dir_body, i);
		data_num = scan->scope + 1;
		for(i = 0; i < data_num; i++)
		{
			scan->psd_data[i] = read_PSD3();
			scan->sonic_data[i] = read_sonic2();
			scan->cds_data[i] = read_cds();
			wait(28);
		}
	}

	return(data_num);
}