#include <3067F.H>
#include "w6v5c.h"

/*C[W捞A荞ݐ͔zϐ*/
/*ʖ邳̕ϒlԂ*/
unsigned char get_gbimage2(unsigned char image[2][128][128], unsigned char mode)
{
unsigned char x, y, i;
unsigned long av;

	av = 0;
	/*Eڂ̎捞*/
	if(mode == 0)
	{
		/*A/DRo[^@WX^ݒ*/
		/*ϊXgbv*/
		AD.CSR.BIT.ADST = 0;
		/*Pꃂ[h*/
		AD.CSR.BIT.SCAN = 0;
		/*vXe[g70*/
		AD.CSR.BIT.CKS = 1;
		/*0cĥ݌JԂϊ*/
		AD.CSR.BIT.CH = 0;
		/***********************************************************************/
		/*I (readMloẘ)*/
		do
		{
			/*Clock sig low*/
			P4DR.BIT.B4 = 0;
			wait0();
			wait0();
			wait0();
			wait0();
			wait0();
			
			/*Clock sig high*/
			P4DR.BIT.B4 = 1;
			wait0();
			wait0();
			wait0();
			wait0();
			wait0();
		}while(P4DR.BIT.B5 == 0);
		/***********************************************************************/
		/*_~[pX*/
		y = 0;
		for(x = 1; x < 128; x++)
		{
			/*Clock sig low*/
			P4DR.BIT.B4 = 0;
			wait0();

			/*Clock sig high*/
			P4DR.BIT.B4 = 1;
			wait0();

			/*Jf[^捞*/
			/*ϊX^[g*/
			AD.CSR.BIT.ADST = 1;
			image[0][y][x] = get_imgdatR();
		}
		for(y = 1; y < 128; y++)
		{
			for(x = 0; x < 128; x++)
			{
				/*Clock sig low*/
				P4DR.BIT.B4 = 0;
				wait0();

				/*Clock sig high*/
				P4DR.BIT.B4 = 1;
				wait0();

				/*Jf[^捞*/
				/*ϊX^[g*/
				AD.CSR.BIT.ADST = 1;
				image[0][y][x] = get_imgdatR();
			}
		}
	}
	else
	{
		/*A/DRo[^@WX^ݒ*/
		/*ϊXgbv*/
		AD.CSR.BIT.ADST = 0;
		/*Pꃂ[h*/
		AD.CSR.BIT.SCAN = 0;
		/*vXe[g70*/
		AD.CSR.BIT.CKS = 1;
		/*1cĥ݌JԂϊ*/
		AD.CSR.BIT.CH = 1;
		/***********************************************************************/
		/*I (readMloẘ)*/
		do
		{
			/*Clock sig low*/
			P4DR.BIT.B4 = 0;
			wait0();
			wait0();
			wait0();
			wait0();
			wait0();
			
			/*Clock sig high*/
			P4DR.BIT.B4 = 1;
			wait0();
			wait0();
			wait0();
			wait0();
			wait0();
		}while(P4DR.BIT.B6 == 0);
		/***********************************************************************/
		/*_~[pX*/
		y = 0;
		for(x = 1; x < 128; x++)
		{
			/*Clock sig low*/
			P4DR.BIT.B4 = 0;
			wait0();

			/*Clock sig high*/
			P4DR.BIT.B4 = 1;
			wait0();

			/*Jf[^捞*/
			/*ϊX^[g*/
			AD.CSR.BIT.ADST = 1;
			image[0][y][x] = get_imgdatL();
		}

		for(y = 1; y < 128; y++)
		{
			for(x = 0; x < 128; x++)
			{
				/*Clock sig low*/
				P4DR.BIT.B4 = 0;
				wait0();

				/*Clock sig high*/
				P4DR.BIT.B4 = 1;
				wait0();

				/*Jf[^捞*/
				/*ϊX^[g*/
				AD.CSR.BIT.ADST = 1;
				image[0][y][x] = get_imgdatL();
			}
		}
	}

	for(y = 0; y < 128; y++)
	{
		for(x = 0; x < 128; x++)
		{
			image[1][y][x] = 255;/*ϐ̏*/
			if(y > 9 && y < 118) av = av + (unsigned long) image[0][y][x];
		}
	}
	av = av / 13824;
	i = (unsigned char) av;

	return(i);
}

/*@W~WsNZ@A荞ݗp*/
void get_gbimage1(unsigned char image_128[2][128][128], unsigned char image_8[8][8])
{
unsigned char	i,j,k, x, y;
unsigned char	pic_xx1, pic_xx2, pic_yy2, ptr_x, ptr_y;
unsigned long	image2[8][8], aa;

	for(i = 0; i < 8; i++)
	{
		for(j = 0; j < 8; j++)
		{
			image2[j][i] = 0;
		}
	}

	
	
	/***********************************************************************/
	pic_xx1 = 0;
	pic_xx2 = 0;
	pic_yy2 = 0;
	ptr_x = 0;
	ptr_y = 0;
	for(y = 0; y < 128; y++)
	{
		for(x = 0; x < 128; x++)
		{
			image2[ptr_y][ptr_x] = image2[ptr_y][ptr_x] + image_128[0][y][x];

			pic_xx1++;
			pic_xx2++;

			if(pic_xx2 == 16)
			{
				pic_xx2 = 0;
				ptr_x++;
				if(ptr_x == 8) ptr_x = 0;
			}

			if(pic_xx1 == 128)
			{
				pic_xx1 = 0;
				pic_yy2++;

				if(pic_yy2 == 16)
				{
					pic_yy2 = 0;
					ptr_y++;
				}
			}
		}
	}
	/***********************************************************************/

	k = 0;
	for(y = 0; y < 8; y++)
	{
		for(x = 0; x < 8; x++)
		{
			aa = image2[y][x] / 256;
			image_8[y][x] = (unsigned char)(aa);
		}
	}

	return;
}

/*IolJLSIփ[h*/
void adj_expose4(unsigned int expose_time)
{
unsigned char	i, j;

	/*IolJLSIփ[h*/
	i = (unsigned char)(expose_time / 256);
	j = (unsigned char)(expose_time & 0x00ff);

	set_register(2, i);
	set_register(3, j);

	do
	{
		/*Clock sig low*/
		P4DR.BIT.B4 = 0;
		wait0();
		wait0();

		/*Clock sig high*/
		P4DR.BIT.B4 = 1;
		wait0();
		wait0();

	}while(P4DR.BIT.B5 == 0);
	do
	{
		/*Clock sig low*/
		P4DR.BIT.B4 = 0;
		wait0();
		wait0();

		/*Clock sig high*/
		P4DR.BIT.B4 = 1;
		wait0();
		wait0();

	}while(P4DR.BIT.B5 == 1);

	return;
}

/*JilԖLSI)̘Io*/
/*Cds̑肩IoԂ߂*/
unsigned char adj_expose3(unsigned int *expose_time1)
{
unsigned char	i, j;
unsigned char	cds;
/*unsigned char	cds_step0[] = {0, 2, 3, 6, 9, 12, 24, 35, 60, 95, 130, 200, 220, 230, 240, 252, 255};*/
unsigned char	cds_step0[] = {0, 2, 3, 5, 8, 11, 18, 29, 42, 88, 130, 200, 220, 230, 240, 252, 255};

unsigned int	expose_time, expose_time0;
float			f1, f2, f3;

	/*Cds*/
	cds = read_cds();

	j = 1;
	expose_time0 = 65535;
	for(i = 0; i < 16; i++)
	{
		if(cds >= cds_step0[i]  && cds < cds_step0[j])
		{
			f1 = (float)(cds - cds_step0[i]) / (float)(cds_step0[j] - cds_step0[i]);
			f2 = (float)(expose_time0 / 2);
			f3 = f2 * f1;
			expose_time = expose_time0 - (unsigned int)f3;
		}
		j++;
		expose_time0 = expose_time0 / 2;
	}
	
	/*IolJLSIփ[h*/
	adj_expose4(expose_time);

	*expose_time1 = expose_time;
	return(cds);
}

/*JilԖLSI)̘Io*/
/*񂩎BeāAʂ̖邳̕ϒlPRO炢ɂȂ悤ɒ*/
unsigned char adj_expose2(unsigned char image_data[2][128][128], unsigned int *expose_time)
{
unsigned char	j, k;
unsigned char	av, av1;

	k = 0;
	av1 = 0;
	for(j = 0; j < 16; j++)
	{
		/*Be*/
		beep(10, 12, 1);
		av = get_gbimage2(image_data, 0);
		beep(10, 24, 1);

		if(av > 120 && av < 145) break;
		else
		{
			if(av1 != 0)
			{
				if(av < 120 && av1 > 145) k = adj_expose(av , 1, expose_time);
				if(av < 120 && av1 < 120) k = adj_expose(av , 0, expose_time);

				if(av > 145 && av1 < 120) k = adj_expose(av , 1, expose_time);
				if(av > 145 && av1 > 145) k = adj_expose(av , 0, expose_time);
			}
			else
			{
				k = adj_expose(av , 0, expose_time);
			}
			av1 = av;
		}

		/*Io͈̒͂𒴂珈f*/
		if(k != 0) break;
	}
	if(k == 0 && j < 16)
	{
		/*K͈*/
		beep(20, 12, 2);
	}
	else
	{
		/*Io͈̓I[o[*/
		beep(20, 48, 3);
	}
	return(av);
}

/*Io*/
/*adj_expose2̉ʂ̃vOBadj_expose2ȊOĂ΂邱Ƃ͂Ȃ*/
unsigned char adj_expose(unsigned char av_levelc, unsigned char mode, unsigned int *expose_time1)
{
unsigned char	high[2], low[2];

unsigned int	expose_time;


	expose_time = *expose_time1;

	high[0] = 145;
	low[0] = 120;

	/*IoI[o[Œs*/
	if(av_levelc > high[0] && expose_time <  2) return(1);
	/*IoA_[Œs*/
	if(av_levelc < low[0]  && expose_time >  32767) return(2);

	/*Io̒*/
	if(mode == 0)
	{
		if(av_levelc > high[0] && expose_time >=  2) expose_time = expose_time / 2;
		if(av_levelc < low[0]  && expose_time <  32768) expose_time = expose_time * 2;
	}
	else
	{
		if(av_levelc > high[0] && expose_time >=  2) expose_time = expose_time / 4 * 3;
		if(av_levelc < low[0]  && expose_time <  32768) expose_time = expose_time / 2 * 3;
	}

	adj_expose4(expose_time);

	*expose_time1 = expose_time;

	return(0);
}
/*********************************************************************/
/*********************************************************************/
/*********************************************************************/
void set_register(unsigned char address, unsigned char data)
{
unsigned char	j,mask_address, mask_data, out_data;

		/*AhX*/
		mask_address = 4;
		for(j = 0; j < 3; j++)
		{
			/*Clock sig low*/
			P4DR.BIT.B4 = 0;
			half_clock();

			out_data = address & mask_address;
			if(out_data != 0) out_data = 1;
			P4DR.BIT.B1 = out_data;
			half_clock();


			/*Clock sig high*/
			P4DR.BIT.B4 = 1;
			half_clock();
			
			/*P4DR.BIT.B1 = 0;*/
			half_clock();

			mask_address = mask_address / 2;
		}

		/*f[^*/
		mask_data = 128;
		for(j = 0; j < 7; j++)
		{
			/*Clock sig low*/
			P4DR.BIT.B4 = 0;
			half_clock();

			out_data = data & mask_data;
			if(out_data != 0) out_data = 1;
			P4DR.BIT.B1 = out_data;
			half_clock();

			/*Clock sig high*/
			P4DR.BIT.B4 = 1;
			half_clock();

			/*P4DR.BIT.B1 = 0;*/
			half_clock();

			mask_data = mask_data / 2;
		}
		{
			/*Clock sig low*/
			P4DR.BIT.B4 = 0;
			half_clock();

			out_data = data & mask_data;
			if(out_data != 0) out_data = 1;
			P4DR.BIT.B1 = out_data;
			half_clock();


			/*Clock sig high*/
			P4DR.BIT.B4 = 1;
			half_clock();

			/*P4DR.BIT.B1 = 0;*/
			P4DR.BIT.B2 = 1;/*Load high*/
			half_clock();


			/*Clock sig low*/
			P4DR.BIT.B4 = 0;
			half_clock();
			
			P4DR.BIT.B2 = 0;/*Load low*/
			half_clock();


			/*Clock sig high*/
			P4DR.BIT.B4 = 1;
			half_clock();
			half_clock();

			mask_data = mask_data / 2;
		}

		{
			/*Clock sig low*/
			P4DR.BIT.B4 = 0;
			half_clock();
			half_clock();

			/*Clock sig high*/
			P4DR.BIT.B4 = 1;
			half_clock();
			half_clock();
		}

}

/************************************************************/
/*ZbgpXo*/
void reset_gb(void)
{
	/*Clock sig low*/
	P4DR.BIT.B4 = 0;
	half_clock();
	P4DR.BIT.B3 = 0;
	half_clock();

	/*Clock sig high*/
	P4DR.BIT.B4 = 1;
	half_clock();
	P4DR.BIT.B3 = 1;
	half_clock();
}
/************************************************************/
/*X^[gpXo*/
void start_gb(void)
{
	/*Clock sig low*/
	P4DR.BIT.B4 = 0;
	half_clock();
	P4DR.BIT.B0 = 1;
	half_clock();

	/*Clock sig high*/
	P4DR.BIT.B4 = 1;
	half_clock();
	P4DR.BIT.B0 = 0;
	half_clock();
}
/*********************************************************************/
/*EڃC[W捞*/
unsigned char get_imgdatR(void)
{
unsigned char	data_c;
int	data_int;

	while(AD.CSR.BIT.ADST == 1);

	data_int = AD.DRA / 64;
	if(data_int > 255) data_int = 255;

	data_c = (char)data_int;


	if(data_c == 0 || data_c == 1) data_c = 2;

	return(data_c);
}
/*ڃC[W捞*/
unsigned char get_imgdatL(void)
{
unsigned char	data_c;
int	data_int;

	while(AD.CSR.BIT.ADST == 1);

	data_int = AD.DRB / 64;
	if(data_int > 255) data_int = 255;

	data_c = (char)data_int;


	if(data_c == 0 || data_c == 1) data_c = 2;

	return(data_c);
}
/*********************************************************************/
void gb_init(void)
{
unsigned char	i, regi[8];
unsigned int	expose_time;


	regi[0] = 128;/*ubNx␳ȂAo̓ItZbgȂ*/
	regi[1] = 0;
	/*Io*/
	expose_time = 64 * 4;
	regi[2] = expose_time / 256;
	regi[3] = expose_time & 0x00ff;
	regi[4] = 0x01;
	regi[5] = 0;
	regi[6] = 0x01;
	regi[7] = 0;

	P4DR.BIT.B0 = 0;/*Start*/
	P4DR.BIT.B1 = 0;/*Data*/
	P4DR.BIT.B2 = 0;/*Load*/
	P4DR.BIT.B3 = 1;/*Reset*/
	P4DR.BIT.B4 = 0;/*Clock*/

	/*ZbgpX*/
	reset_gb();

	/*WX^[Zbg(vW{j)*/
	for(i = 0; i < 8; i++)
	{
		set_register(i, regi[i]);
	}

	/*X^[gpX*/
	start_gb();
}