#include <3067F.H>

void print_c_sci1(unsigned char	data);
void print_c_sci1b(unsigned char	data);
void print_c_sci0(unsigned char	data);
void print_s_sci1(char string[80]);
unsigned char read_c_sci1(void);
unsigned char read_c_sci0(void);
unsigned char read_c_sci1b(void);
unsigned char read_c_sci0b(void);

void wait(unsigned int time);


/*************************************************/
/*O`UTTRT̐VA|[giTubotj֏o͂*/
void print_ii_sci0(unsigned int data)
{
unsigned int	ii;
unsigned char	data_L, data_H;

	if(data > 255)
	{
		ii = data / 256;
		data_H = (unsigned char)ii;
	}
	else
	{
		ii = 0;
		data_H = 0;
	}

	ii = data - ii * 256;
	data_L = (unsigned char)ii;

	print_c_sci0(data_H);
	print_c_sci0(data_L);
	return;
}

/*************************************************/
/*̐^[~iʂɕ\(AsciiR[ho)*/
/*ob*/
void print_ii_sci1(unsigned int data)
{
unsigned int		org_data;
unsigned int		i, j, bitptn;
unsigned char		string[16];

	org_data = data;

	bitptn = 10000;
	for(i = 0; i < 5; i++)
	{
		j = data / bitptn;
		string[i] = '0' + j;
		data = data - bitptn * j;
		bitptn = bitptn / 10;
	}

	for(i = 0; i < 4; i++)
	{
		if(string[i] == '0') string[i] = ' ';
		else break;
	}

	string[5] = 0x0d;
	string[6] = 0x0a;
	string[7] = 0x00;

	for(i = 0; i < 8; i++)
	{
		while(SCI1.SSR.BIT.TDRE == 0);
		SCI1.TDR = string[i];
		SCI1.SSR.BIT.TDRE = 0;
	}
	return;
}
/*************************************************************/
/*O`QTT̐^[~iʂɕ\(AsciiR[ho)*/
void print_c_sci1(unsigned char	data)
{

unsigned int		org_data;
unsigned char		i, j, string[16];

	org_data = data;

	/*100̈*/
	j = (unsigned char)(data / 100);
	if(j != 0) string[0] = 0x30 + j;
	else	   string[0] = 0x20;
	
	/*10̈*/
	data = data - (int)j * 100;
	j = (unsigned char)(data / 10);
	if(j != 0) string[1] = 0x30 + j;
	if(j == 0 && org_data >= 100)string[1] = 0x30;
	if(j == 0 && org_data < 100) string[1] = 0x20;
	
	/*1̈*/
	data = data - (int)j * 10;
	j = (unsigned char)data;	
	string[2] = 0x30 + j;

	string[3] = 0x0d;
	string[4] = 0x0a;
	string[5] = 0x00;

	for(i = 0; i < 5; i++)
	{
		while(SCI1.SSR.BIT.TDRE == 0);
		SCI1.TDR = string[i];
		SCI1.SSR.BIT.TDRE = 0;
	}

	return;
}

/*unsigned int ϐ 2 oCgVA|[g֏o͂*/
void print_ii_sci1b(unsigned int data)
{
unsigned int	ii;
unsigned char	data_L, data_H;

	if(data > 255)
	{
		ii = data / 256;
		data_H = (unsigned char)ii;
	}
	else
	{
		ii = 0;
		data_H = 0;
	}

	ii = data - ii * 256;
	data_L = (unsigned char)ii;

	print_c_sci1b(data_H);
	print_c_sci1b(data_L);

	return;
}


/*charϐPoCgVA|[g֏o͂*/
void print_c_sci2b(unsigned char data)
{

	while(SCI2.SSR.BIT.TDRE == 0);
	SCI2.TDR = data;
	SCI2.SSR.BIT.TDRE = 0;

	return;
}

/*charϐPoCgVA|[g֏o͂*/
void print_c_sci1b(unsigned char data)
{

	while(SCI1.SSR.BIT.TDRE == 0);
	SCI1.TDR = data;
	SCI1.SSR.BIT.TDRE = 0;

	return;
}

/*charϐPoCgVA|[g֏o͂*/
void print_c_sci0(unsigned char	data)
{

	while(SCI0.SSR.BIT.TDRE == 0);
	SCI0.TDR = data;
	SCI0.SSR.BIT.TDRE = 0;

	return;
}

/*charϐ80oCg max VA|[g֏o͂ibXgOj*/
void print_s_sci1(char string[80])
{
unsigned char	i;

	i = 0;
	do
	{
		print_c_sci1b(string[i]);
		i++;
	}while(string[i] != 0 && i < 80);

	if(string[i - 1] != '=')
	{
		print_c_sci1b(0x0d);
		print_c_sci1b(0x0a);
	}

	return;
}

/*O`XXX̐VA|[g͂*/
unsigned int read_i_sci1(void)
{
unsigned int	k, data, bitptn;

	data = 0;
	bitptn = 100;
	for(k = 0; k < 3; k++)
	{
		data = data + (read_c_sci1() - '0') * bitptn;
		bitptn = bitptn / 10;
	}
	return(data);
}

/*O`UTTRT̐VA|[giuaĂobj͂*/
unsigned int read_ii_sci1(void)
{
unsigned int	k, data, bitptn;

	data = 0;
	bitptn = 10000;
	for(k = 0; k < 5; k++)
	{
		data = data + (read_c_sci1() - '0') * bitptn;
		bitptn = bitptn / 10;
	}
	return(data);
}

/*O`UTTRT̐VA|[giubĂobj͂*/
unsigned int read_ii_sci1b(void)
{
unsigned int	data;
unsigned int	data_L, data_H;

	data_H = (unsigned int)read_c_sci1();
	data_L = (unsigned int)read_c_sci1();
	data = data_H * 256 + data_L;
	return(data);
}


/*O`UTTRT̐VA|[giTubotj͂*/
unsigned int read_ii_sci0(void)
{
unsigned int	data;
unsigned int	data_L, data_H;

	data_H = (unsigned int)read_c_sci0();
	data_L = (unsigned int)read_c_sci0();
	data = data_H * 256 + data_L;
	return(data);
}

/*charϐPoCgVA|[g͂*/
/*v܂ő҂@^CAEg͂POb*/
/*ITU1̐ݒԂɒӂ邱*/
unsigned char read_c_sci1(void)
{
unsigned char	data;
unsigned int	time_out;

	if(ITU1.TCNT > 65500) ITU1.TCNT = 0;
	time_out = ITU1.TCNT;

	while(SCI1.SSR.BIT.RDRF == 0)
	{
		if((ITU1.TCNT - time_out) > 10)
		{
			return(0);
		}
	}

	data = SCI1.RDR;
	SCI1.SSR.BIT.RDRF = 0;

	return(data);
}

/*charϐPoCgVA|[g͂*/
/*f[^܂ő҂*/
unsigned char read_c_sci0(void)
{
unsigned char	data;

	while(SCI0.SSR.BIT.RDRF == 0);
	data = SCI0.RDR;
	SCI0.SSR.BIT.RDRF = 0;

	return(data);
}

/*charϐPoCgVA|[g͂*/
/*vȂ΋A*/
unsigned char read_c_sci1b(void)
{
unsigned char	data;

	if(SCI1.SSR.BIT.RDRF == 0) return(0);
	data = SCI1.RDR;
	SCI1.SSR.BIT.RDRF = 0;

	return(data);
}

/*charϐPoCgVA|[g͂*/
unsigned char read_c_sci0b(void)
{
unsigned char	data;

	if(SCI0.SSR.BIT.RDRF == 0)return(0);
	data = SCI0.RDR;
	SCI0.SSR.BIT.RDRF = 0;

	return(data);
}
void init_gyro(unsigned int gyro[3][2], unsigned int gyro_newtral[3])
{
unsigned char		i, flg_gy[2];

	/*WCÒ҂EEERDTb*/
	P4DR.BIT.B7 = 0;
	P4DR.BIT.B7 = 0;
	for(i = 0; i < 175; i++)
	{
		ITU0.TCNT = 0;
		P4DR.BIT.B7 = 1;
		P4DR.BIT.B7 = 1;

		flg_gy[0] = 0;
		flg_gy[1] = 0;
		/*WC̗͂L^*/
		do{
			if(P7DR.BIT.B5 == 0 && flg_gy[0] == 0)
			{
				gyro[1][0] = ITU0.TCNT;
				flg_gy[0] = 1;
			}
			if(P7DR.BIT.B7 == 0 && flg_gy[1] == 0)
			{
				gyro[2][0] = ITU0.TCNT;
				flg_gy[1] = 1;
			}
		}while(flg_gy[0] == 0 || flg_gy[1] == 0);

		/*  1.5 m sec  iPQW̏o͂ƍ킹j*/
		while(ITU0.TCNT < 3963);
		P4DR.BIT.B7 = 0;
		P4DR.BIT.B7 = 0;

		flg_gy[0] = 0;
		flg_gy[1] = 0;
		/*WC̗͂オL^*/
		do{
			if(P7DR.BIT.B5 == 1 && flg_gy[0] == 0)
			{
				gyro[1][1] = ITU0.TCNT;
				flg_gy[0] = 1;
			}
			if(P7DR.BIT.B7 == 1 && flg_gy[1] == 0)
			{
				gyro[2][1] = ITU0.TCNT;
				flg_gy[1] = 1;
			}
		}while(flg_gy[0] == 0 || flg_gy[1] == 0);

		gyro_newtral[1] = gyro[1][1] - gyro[1][0];
		gyro_newtral[2] = gyro[2][1] - gyro[2][0];

		while(ITU0.TCNT < 50000);
	}
}
