#include <3067F.H>
#include "w6v5c.h"

/*********************************************************************/
/**     CCPUPC̒ʐM[`                                 **/
/*********************************************************************/
char sio_comm1(struct SIO *sio, struct SWITCHES *switches
			   , unsigned int	mortion_arm[4096], unsigned int ptr_arm[128])
{
unsigned char	i, j, k, x, y, mode, data_num;
unsigned char	image_8[8][8], brightness[64];
unsigned char	raw_data[64], raw_data2[3][91], image_data[2][128][128];

unsigned int	ii, sonic_data[64];

struct SCAN scan;

	/*eSCI̐ڑ
	OFNo.2@TuCPU
	PFPC
	QF
	*/


	/*C[W̑Mi𑜓xj*/
	if(sio->command == 'a')
	{
		get_gbimage2(image_data, '0');
		get_gbimage1(image_data, image_8);
	
		for(y = 0; y < 8; y++)
		{
			for(x = 0; x < 8; x++)
			{
				print_c_sci1b(image_8[y][x]);
			}
		}
	}

	/*Io̎*/
	if(sio->command == 'b')
	{
		print_c_sci1b(sio->command);/*ʐM*/
		i = read_c_sci1() - '0';/*mode code*/

		if(i == 0)
			k = adj_expose2(image_data, &sio->expose_time);
		else if(i == 1)
			k = adj_expose3(&sio->expose_time);
		else
		{
			sio->expose_time = read_ii_sci1();/*VB̃vOp*/
			adj_expose4(sio->expose_time);
		}

		print_c_sci1b('0');
	}

	/*C[W̑Mi𑜓xj*/
	if(sio->command == 'c')
	{
		print_c_sci1b(sio->command);/*ʐM*/

		i = read_c_sci1();
		if(i != '0')	i = 1;/**/
		else			i = 0;/*E*/

		j = get_gbimage2(image_data, i);
		/*i = get_line_image(image_data);*/
		for(y = 0; y < 128; y++)
		{
			for(x = 0; x < 128; x++)
			{
				print_c_sci1b(image_data[0][y][x]);
			}
		}
	}

	/*rnmhbP*/
	if(sio->command == 'd')
	{
		ii = read_sonic2();
		print_ii_sci1b(ii);
	}

	/*苗̑s*/
	if(sio->command == 'e')
	{
	}

	/*RpXf[^ǂݎ*/
	if(sio->command == 'f')
	{
		i = P5DR.BYTE & 7;
		print_c_sci1b(i);
	}

	/*bf[^ǂݎ*/
	if(sio->command == 'g')
	{
		i = read_cds();
		/*print_c_sci1(i);*/
		print_c_sci1b(i);
	}

	/*f̃eXg*/
	if(sio->command == 'h')
	{
		print_s_sci1("Start !");
		for(i = 0; i < 100; i++)
		{
			print_c_sci2b('A');
			wait(1);
		}
		print_s_sci1("Finish !");

	}

	/*Ioԃ|[g*/
	if(sio->command == 'i')
	{
		print_ii_sci1b(sio->expose_time);
	}

	/*OCx|[g*/
	if(sio->command == 'j')
	{
		ii = read_therm();
		print_ii_sci1b(ii);
	}

	/*PWOxorcXLiQx)*/
	if(sio->command == 'k')
	{
		print_c_sci1b(sio->command);/*ʐM*/
		mode = read_c_sci1();

		/*Qx݂łPWOxXL*/
		if(mode == '0')
		{
			i = scan_PSD0(0x01, raw_data2, 90);
			/*PSD*/
			for(i = 0; i < 91; i++)		print_c_sci1b(raw_data2[0][i]);
			/*Compass*/
			for(i = 0; i < 91; i++)		print_c_sci1b(raw_data2[1][i]);
		}
		else
		{
			scan.mode = mode;
			scan.dir_body = read_c_sci1();
			scan.dir_head = read_c_sci1();
			scan.dir_v = read_c_sci1();
			scan.scope = read_c_sci1();

			data_num = scan2(&scan);

			print_c_sci1b(data_num);
			/*PSD*/
			for(i = 0; i < data_num; i++) print_c_sci1b(scan.psd_data[i]);
			/*Sonic*/
			for(i = 0; i < data_num; i++) print_c_sci1b(scan.sonic_data[i]);
			/*Cds*/
			for(i = 0; i < data_num; i++) print_c_sci1b(scan.cds_data[i]);
		}
	}

	/*PWOxorc^rnmhbiPOx)*/
	if(sio->command == 'l')
	{
		i = scan0(0x01, raw_data, sonic_data);
		for(i = 0; i < 19; i++)
		{
			print_c_sci1b(raw_data[i]);
		}

		for(i = 0; i < 19; i++)
		{
			print_ii_sci1b(sonic_data[i]);
		}
	}

	/*RUOxorc^rnmhbiPOx)*/
	if(sio->command == 'm')
	{
		i = scan1(raw_data, sonic_data, brightness);

		for(i = 0; i < 37; i++)
		{
			print_c_sci1b(raw_data[i]);
		}

		for(i = 0; i < 37; i++)
		{
			print_ii_sci1b(sonic_data[i]);
		}

		for(i = 0; i < 37; i++)
		{
			print_c_sci1b(brightness[i]);
		}
	}

	/*C^[o^C}[ϑ*/
	if(sio->command == 'y')
	{
		print_c_sci1b(sio->command);/*ʐM*/

		print_s_sci1("<< Thermo logging>>");
		print_s_sci1("0 : Start");
		print_s_sci1("1 : Terminate");
		print_s_sci1("2 : Data down load");
		print_s_sci1("3 : Show current status");
		print_s_sci1("Input mode number (0 - 3) : ");
		mode = read_c_sci1();
		print_s_sci1(" ");

		/*X^[g*/
		if(mode == '0')
		{
			sio->interval_mode = 1;
			sio->log_interval = 600;/*10min(600sec)*/

			/*ϐ̏*/
			sio->log_datanum = 0;
			sio->log_time0 = 0;
			for(ii = 0; ii < 288; ii++)
			{
				sio->log_thermo[ii]	= 0;
				sio->log_cds[ii]	= 0;
			}
			/*ṽZbg*/
			ITU1.TCNT = 599;

			print_s_sci1("Thermo logging Started!");
		}

		/*Gh*/
		if(mode == '1')
		{
			sio->interval_mode = 0;
			print_s_sci1("Thermo logging Terminated!");
		}

		/*f[^M*/
		if(mode == '2')
		{
			/*data number*/
			print_ii_sci1(sio->log_datanum);
			/*PSD*/
			for(ii = 0; ii < sio->log_datanum; ii++)
			{
				/*print_c_sci1b(sio->log_cds[ii]);*/
				print_c_sci1(sio->log_cds[ii]);
			}
			/*thermo*/
			for(ii = 0; ii < sio->log_datanum; ii++)
				print_ii_sci1(sio->log_thermo[ii]);
		}

		/*ԕ\*/
		if(mode == '3')
		{
			if(sio->interval_mode == 1)
				print_s_sci1("Thermo logging is running.");
			else
				print_s_sci1("Thermo logging is not running.");
			
			/*data number*/
			ii = sio->log_datanum - 1;
			print_s_sci1("Data num  :=");
			print_ii_sci1(ii);
			/*PSD*/
			/*print_c_sci1b(sio->log_cds[ii]);*/
			print_s_sci1("Cds   data:=");
			print_c_sci1(sio->log_cds[ii]);
			/*thermo*/
			print_s_sci1("Therm data:=");
			print_ii_sci1(sio->log_thermo[ii]);
		}
	}

	/*샂[hؑ*/
	if(sio->command == 'z')
	{
		print_s_sci1("Select running mode number 0 - 9.");
		print_s_sci1("(0: Remote control, 1-9: Autonomous running");
		sio->run_mode = read_c_sci1() - '0';
	}

	return(0);
}

/*********************************************************************/
/**     PC̃R}hNo.1TuCPU֓]    **/
/*********************************************************************/
char sio_comm2(struct SIO *sio, struct SWITCHES *switches
			   , unsigned int	mortion_arm[4096], unsigned int ptr_arm[128])
{
unsigned char	i, j, k, command2;
unsigned char	sio_buff[6];

unsigned int	ii;

	/*eSCI̐ڑ
	OFNo.2@TuCPU
	PFPC
	QFFM gX~b^[
	*/

	/*ړ֘AR}h*/
	if(sio->command == '0')
	{
		/*M*/
		print_c_sci1b(sio->command);

		/*TuR}hM*/
		command2 = read_c_sci1();

		/*~*/
		if(command2 == '0')
		{
			print_c_sci0(sio->command);
			/*M҂*/
			j = read_c_sci0();
			/*TuR}hM*/
			print_c_sci0(command2);
		}

		/*w肵Ȃړ*/
		if(command2 == '1')
		{
			print_c_sci0(sio->command);
			/*M҂*/
			j = read_c_sci0();
			/*TuR}hM*/
			print_c_sci0(command2);
		}

		/*ړp[^Zbg*/
		if(command2 == '2')
		{
			for(k = 0; k < 4; k++)
			{
				sio_buff[k] = read_c_sci1();
			}

			print_c_sci0(sio->command);
			/*M҂*/
			j = read_c_sci0();
			/*TuR}hM*/
			print_c_sci0(command2);

			for(k = 0; k < 4; k++)
			{
				print_c_sci0(sio_buff[k]);
			}
		}

		/*苗̈ړ*/
		if(command2 == '3')
		{
			sio_buff[0] = read_c_sci1();
			sio_buff[1] = read_c_sci1();
			ii = read_ii_sci1b();

			print_c_sci0(sio->command);
			/*M҂*/
			j = read_c_sci0();
			/*TuR}hM*/
			print_c_sci0(command2);

			print_c_sci0(sio_buff[0]);
			print_c_sci0(sio_buff[1]);
			print_ii_sci0(ii);
		}

	}

	/*ZTǂݎ聕|[g*/
	if(sio->command == '2')
	{
		/*M*/
		print_c_sci1b(sio->command);

		/*TuR}hM*/
		command2 = read_c_sci1();

		/*ړԃ|[g*/
		if(command2 == '0')
		{
			print_c_sci0(sio->command);
			/*M҂*/
			j = read_c_sci0();
			/*TuR}hM*/
			print_c_sci0(command2);

			for(k = 0; k < 5; k++)
			{
				sio_buff[k] = read_c_sci0();
			}

			for(k = 0; k < 5; k++)
			{
				print_c_sci1b(sio_buff[k]);
			}
		}

		/*orc*/
		if(command2 == '1')
		{
			print_c_sci0(sio->command);
			/*M҂*/
			j = read_c_sci0();
			/*TuR}hM*/
			print_c_sci0(command2);

			for(i = 0; i < 3; i++)
			{
				sio_buff[i] = read_c_sci0();
			}

			for(i = 0; i < 3; i++)
			{
				print_c_sci1b(sio_buff[i]);
			}
		}
		/*for͂܂Ȃ̂ŁAǂݎR}hȂ*/
	}


	/*PSD ON/OFF*/
	if(sio->command == '4')
	{
		/*Tubot@mDQ̏*/
		print_c_sci1b('4');/*ʐM*/

		sio_buff[0] = read_c_sci1();

		print_c_sci0('4');
		/*҂*/
		j = read_c_sci0();

		print_c_sci0(sio_buff[0]);

		/*Cbot̏*/
		if(sio_buff[0] == '1')	PADR.BIT.B7 = 1;
		else					PADR.BIT.B7 = 0;
	}

	if(sio->command == '9')
	{
		for(j = 0; j < 12; j++)
		{
			print_ii_sci1(sio->servo_buff[j]);
		}
	}
	return(0);
}

/*********************************************************************/
/**     PC̃R}hNo.2TuCPU֓]    **/
/*********************************************************************/
char sio_comm3(struct SIO *sio, struct SWITCHES *switches
			   , unsigned int	mortion_arm[4096], unsigned int ptr_arm[128])
{
unsigned char	i, j, k, l;
unsigned char	sio_buff[16];
unsigned int	ii, jj, sio_buff_i[6], servo_data_arm[4][2];

	/*eSCI̐ڑ
	OFNo.2@TuCPU
	PFPC
	QF
	*/
	/*֐߃f[^]iP֐ߕj*/
	if(sio->command == 'A')
	{
		print_c_sci1b(sio->command);/*ʐM*/

		/*֐ߔԍM*/
		/*j = (unsigned char)read_i_sci1();*/
		j = read_c_sci1();
		/*f[^M*/
		/*ii = read_ii_sci1();*/
		ii = read_ii_sci1b();

		print_c_sci0(sio->command);
		/*҂*/
		i = read_c_sci0();

		print_c_sci0(j);
		print_ii_sci0(ii);
	}

	/*֐߃f[^]iP|Cgj*/
	if(sio->command == 'B')
	{
		print_c_sci1b(sio->command);/*ʐM*/

		/*obM*/
		for(j = 0; j < 12; j++)
		{
			sio->servo_buff[j] = read_ii_sci1b();
		}

		/*Tubot֑M*/
		print_c_sci0(sio->command);
		i = read_c_sci0();

		for(j = 0; j < 12; j++)
		{
			print_ii_sci0(sio->servo_buff[j]);
		}
	}

	/*ADXL202̏ԑM*/
	if(sio->command == 'C')
	{
		print_c_sci0(sio->command);
		sio_buff_i[0] = read_ii_sci0();
		sio_buff_i[1] = read_ii_sci0();

		print_ii_sci1b(sio_buff_i[0]);
		print_ii_sci1b(sio_buff_i[1]);
	}

	/*RC GYRȌԑM*/
	if(sio->command == 'D' && switches->gyro_on == 1)
	{
	}

	/*g`f[^PC󂯎*/
	if(sio->command == 'E')
	{
		print_c_sci1b(sio->command);/*ʐM*/

		/*obM********************************/
		jj = 0;
		do{
			mortion_arm[jj] = read_ii_sci1();
			jj++;
		}while(mortion_arm[jj - 1] != 9999);/*9999IR[h*/

		/*eg`f[^̃f[^PC󂯎*/
		jj = 0;
		do{
			ptr_arm[jj] = read_ii_sci1();
			jj++;
		}while(ptr_arm[jj - 1] != 9999);/*9999IR[h*/

		/*Tubot֑M********************************/
		print_c_sci0(sio->command);
		/*҂*/
		i = read_c_sci0();

		jj = 0;
		do{
			print_ii_sci0(mortion_arm[jj]);
			jj++;
		}while(mortion_arm[jj - 1] != 9999);/*9999IR[h*/

		jj = 0;
		do{
			print_ii_sci0(ptr_arm[jj]);
			jj++;
		}while(ptr_arm[jj - 1] != 9999);/*999IR[h*/
	}

	/*s铮g`ԍf[^PC󂯎*/
	if(sio->command == 'F')
	{
		print_c_sci1b(sio->command);/*ʐM*/

		j = read_i_sci1();

		print_c_sci0(sio->command);
		/*҂*/
		i = read_c_sci0();

		print_c_sci0(j);
	}

	/*R}hf[^󂯎*/
	if(sio->command == 'G')
	{
		print_c_sci1b(sio->command);/*ʐM*/

		for(j = 0; j < 5; j++) sio_buff[j] = (unsigned char)read_i_sci1();

		print_c_sci0('G');
		/*҂*/
		i = read_c_sci0();

		for(j = 0; j < 5; j++) print_c_sci0(sio_buff[j]);
	}

	/*Xe[^X|[g*/
	if(sio->command == 'H')
	{
		i = check_status_servo();
		print_c_sci1b(i);
		/*print_c_sci1(i);*/
	}

	/*r𓮂*/
	if(sio->command == 'I')
	{
		print_c_sci1b(sio->command);/*ʐM*/

		/*ރLN^M@HFiށj^VFiグ낵j*/
		j = read_c_sci1();

		/*1 or 0 󂯎*/
		/*V & 1: rグ*/
		/*H & 1: rL*/
		k = (unsigned char)read_i_sci1();

		/*ڕW̎󂯎if[^j*/
		/*Eɂ̂܂܏oBɂ͕]*/
		ii = read_ii_sci1();

		print_c_sci0(sio->command);
		/*҂*/
		i = read_c_sci0();

		print_c_sci0(j);
		print_c_sci0(k);
		print_ii_sci0(ii);
	}

	/*̃^b`ZT񑗐M*/
	if(sio->command == 'J')
	{
		print_c_sci0(sio->command);
		j = read_c_sci0();

		print_c_sci1b(j);
		/*print_c_sci1(j);*/
	}

	/*qbT[{@Mnm^nee*/
	if(sio->command == 'K')
	{
		print_c_sci1b(sio->command);/*ʐM*/

		/*ރLN^M@1FMó^0FM~*/
		j = read_c_sci1() - '0';

		print_c_sci0(sio->command);
		/*҂*/
		i = read_c_sci0();

		print_c_sci0(j);
	}

	/*̂̊֐߂RCT[{ݒlM*/
	if(sio->command == 'L')
	{
		print_c_sci1b(sio->command);/*ʐM*/

		/*R}h͕K12oCg*/
		for(j = 0; j < 12; j++) sio_buff[j] = read_c_sci1();

		print_c_sci0(sio->command);
		/*҂*/
		i = read_c_sci0();

		for(j = 0; j < 12; j++) print_c_sci0(sio_buff[j]);
	}

	/*dr̓d|[g*/
	if(sio->command == 'M')
	{
		print_c_sci1b(sio->command);/*ʐM*/

		print_c_sci0(sio->command);
		j = read_c_sci0();

		print_c_sci1b(j);
	}

	/*xZT@ʒu|[g*/
	if(sio->command == 'N')
	{
		print_c_sci0(sio->command);
		ii = read_ii_sci0();
		jj = read_ii_sci0();

		print_ii_sci1b(ii);
		print_ii_sci1b(jj);
	}

	/*r֐߃f[^󂯎iP|Cgj*/
	if(sio->command == 'O')
	{
		print_c_sci1b(sio->command);/*ʐM*/

		/*[hM*/
		k = read_c_sci1();

		/*֐߁@o̓f[^M*/
		for(j = 0; j < 8; j++) sio->servo_buff[j] = read_ii_sci1b();
		
		/*Đԁi|Cg)M*/
		l = read_c_sci1();

		print_c_sci0(sio->command);
		/*҂*/
		i = read_c_sci0();

		print_c_sci0(k);
		for(j = 0; j < 8; j++) print_ii_sci0(sio->servo_buff[j]);
		print_c_sci0(l);
	}

	/*̊֐߃f[^󂯎iP|Cgj*/
	if(sio->command == 'P')
	{
		print_c_sci1b(sio->command);/*ʐM*/

		/*[hM*/
		k = read_c_sci1();

		/*֐߁@o̓f[^M*/
		for(j = 0; j < 3; j++) sio->servo_buff[j] = read_ii_sci1b();
		
		/*Đԁi|Cg)M*/
		l = read_c_sci1();
			
		print_c_sci0(sio->command);
		/*҂*/
		i = read_c_sci0();

		print_c_sci0(k);
		for(j = 0; j < 3; j++) print_ii_sci0(sio->servo_buff[j]);
		print_c_sci0(l);
	}

	/*r̂qbT[{@o͒̃f[^|[g*/
	if(sio->command == 'Q')
	{
		/*R}h]*/
		print_c_sci0(sio->command);

		/*f[^M*/
		for(j = 0; j < 2; j++)
		{
			for(i = 0; i < 4; i++)
			{
				servo_data_arm[i][j] = read_ii_sci0();
			}
		}

		/*ob֓]*/
		for(j = 0; j < 2; j++)
		{
			for(i = 0; i < 4; i++)
			{
				print_ii_sci1b(servo_data_arm[i][j]);
			}
		}
	}

	return(0);
}

/************************************************************************/
/*p^[Lœ𓮂                                       */
/* dir_h	:̐px@O`PWO                              */
/* dir_v	:̐px@ROH`PTOHỉ͈͐j*/
/* dir_h2	:̐px@O`PWO                              */
/************************************************************************/
void move_head(unsigned char dir_h, unsigned char dir_v, unsigned char dir_h2, unsigned char time)
{
unsigned char	i;

	/*
	dir_h = dir_h / 2;
	dir_v = dir_v / 2;
	*/

	print_c_sci0('G');
	i = read_c_sci0();

	print_c_sci0(0);/*p^[*/
	print_c_sci0(dir_h);
	print_c_sci0(dir_v);
	print_c_sci0(dir_h2);/**/
	print_c_sci0(time);

}

/************************************************************************/
/*p^[œ𓮂                                       */
/* dir_h	:̐px@O`PWO                              */
/* dir_v	:̐px@ROH`PTOHỉ͈͐j*/
/* dir_h2	:̐px@O`PWO                              */
/************************************************************************/
void move_head2(unsigned char dir_h, unsigned char dir_v,  unsigned char dir_h2, unsigned char time)
{
unsigned char	i;

	/*
	dir_h = dir_h / 2;
	dir_v = dir_v / 2;
	*/

	print_c_sci0('G');
	i = read_c_sci0();

	print_c_sci0(1);/*p^[*/
	print_c_sci0(dir_h);
	print_c_sci0(dir_v);
	print_c_sci0(dir_h2);
	print_c_sci0(time);

}

/*sJn*/
void go(unsigned char dist_limit, unsigned char dist_limit_dir)
{
unsigned char	i;

	print_c_sci0('1');
	i = read_c_sci0();

	print_c_sci0(dist_limit);
	print_c_sci0(dist_limit_dir);
}

/*s~*/
void stop(void)
{
unsigned char	i;

	print_c_sci0('0');
	i = read_c_sci0();
}

void set_speed(unsigned char speed_R, unsigned char speed_L,
							unsigned char dirR, unsigned char dirL)
{
unsigned char	i;

	print_c_sci0('8');
	i = read_c_sci0();

	print_c_sci0(speed_R);
	print_c_sci0(speed_L);
	print_c_sci0(dirR);
	print_c_sci0(dirL);
}
