#include <3067F.H>
#include "w6v5c.h"

unsigned char read_cds(void)
{
unsigned char i;

	/*A/DRo[^@WX^ݒ*/
	/*ϊXgbv*/
	AD.CSR.BIT.ADST = 0;
	/*Pꃂ[h*/
	AD.CSR.BIT.SCAN = 0;
	/*vXe[g130*/
	AD.CSR.BIT.CKS = 0;
	/*2cĥݕϊ*/
	AD.CSR.BIT.CH = 2;
	/*ϊX^[g*/
	AD.CSR.BIT.ADST = 1;

	while(AD.CSR.BIT.ADST == 1);

	i = AD.DRC / 256;
	return(i);
}


/*gṽf[^擾*/
unsigned int read_sonic2(void)
{
unsigned char	j;
unsigned int	ii;

	/*ő僌W炩߃Zbg*/
	/*pXԂȂꍇ́A̒l߂lƂȂ*/
	ii = 3450;
	j = 0;

	ITU0.TCNT = 0;
	while(P5DR.BIT.B3 == 0)
	{
		if(ITU0.TCNT > 62500)
		{
			/*WI[o[*/
			j = 1;
			break;
		}
	};

	while(P5DR.BIT.B3 == 1);

	/*Jn*/
	ITU0.TCNT = 0;
	while(P5DR.BIT.B3 == 0)
	{
		if(ITU0.TCNT > 62500)
		{
			/*WI[o[*/
			j = 1;
			break;
		}
	};
	if(j != 1)
	{
		ii = ITU0.TCNT / 103;
		ii = ii * 11;
		ii = ii / 2;
	}
	/*
	print_ii_sci1(ii);
	*/
	return(ii);
}
/*********************************************************************/
/*********************************************************************/
/*^b`ZT[̂҂*/
void wait_touch(void)
{
unsigned char	i;

	do{
		wait_sec(1);

		/*^b`ZT[ǂݎ*/
		/*ړjbgType 1̃op[
		print_c_sci0('2');
		*/
		/**/
		print_c_sci0('J');
		i = read_c_sci0();

		beep(10, 12, 1);
	}while(i == 255);

	beep(10, 12, 2);
	wait_sec(1);
}

/*qbT[{[Vf[^ĐǂmF*/
unsigned char check_status_servo(void)
{
unsigned char	i;

	print_c_sci0('H');
	wait(40);
	i = read_c_sci0();
	return(i);
}

/*qbT[{Î҂*/
void wait_servo(void)
{
unsigned char	i;

	do{
		wait(100);
		i = check_status_servo();
	}while(i == 1);
}

/*sǂmF*/
void check_status_go(unsigned char status[2])
{

	print_c_sci0('6');
	status[0] = read_c_sci0();/*s͂PA~͂O*/
	status[1] = read_c_sci0();/*s̓A{[gɂ̎̃JEg*/
							   /*̑̂Ƃ̓[*/
	wait(40);
	return;
}


/*RpXf[^̃^[~io*/
unsigned char read_compass(void)
{
unsigned char	i;

	i = P5DR.BYTE & 7;
	if(i == 6) print_s_sci1("E");
	if(i == 2) print_s_sci1("NE");
	if(i == 3) print_s_sci1("N");
	if(i == 1) print_s_sci1("SW");
	if(i == 0) print_s_sci1("S");
	if(i == 4) print_s_sci1("SE");
	if(i == 5) print_s_sci1("W");
	if(i == 7) print_s_sci1("NW");

	return(i);
}

/******************************************************************/
/**  PSDZT[֌W̃Tu[`@@*****************************/
/******************************************************************/
/*CCPUPSDf[^擾*/
unsigned char read_PSD3(void)
{
unsigned char i;

	/*A/DRo[^@WX^ݒ*/
	/*ϊXgbv*/
	AD.CSR.BIT.ADST = 0;
	/*Pꃂ[h*/
	AD.CSR.BIT.SCAN = 0;
	/*vXe[g130*/
	AD.CSR.BIT.CKS = 0;
	/*3cĥݕϊ*/
	AD.CSR.BIT.CH = 3;
	/*ϊX^[g*/
	AD.CSR.BIT.ADST = 1;

	while(AD.CSR.BIT.ADST == 1);

	i = AD.DRD / 256;
	return(i);
}

/*orc̐f[^Pʂ̃f[^ɕϊ*/
float raw2cm_PSD(unsigned char raw_data)
{
float		workf, cm_data;

	workf = (float)raw_data;
	if(raw_data > 25)
	{
		/*cm Zf[^*/
		if(raw_data < 60)
		{
			cm_data = -(float)0.0001 * workf * workf * workf + (float)0.0292 * workf * workf
				- (float)2.848 * workf + (float)111.63;
		}
		else
		{
			cm_data = -(float)0.2082 * workf + (float)34.086;
		}
	}
	else
	{
		/*WI[o[̏ꍇ*/
		cm_data = 60.0;
	}

	return(cm_data);
}

/*orc̐f[^mmPʂ̃f[^ɕϊ*/
float raw2mm_PSD(unsigned char raw_data)
{
float		workf, mm_data;

	workf = (float)raw_data;
	if(raw_data > 25)
	{
		/*cm Zf[^*/
		if(raw_data < 60)
		{
			mm_data = -(float)0.0001 * workf * workf * workf + (float)0.0292 * workf * workf
				- (float)2.848 * workf + (float)111.63;
		}
		else
		{
			mm_data = -(float)0.2082 * workf + (float)34.086;
		}

		mm_data = mm_data * (float)10.0;
	}
	else
	{
		/*WI[o[̏ꍇ*/
		mm_data = 600.0;
	}

	return(mm_data);
}

/*orcZT[茋ʓǂݎif[^^f[^j*/
/*Cbot̕ǂݍ*/
void read_PSD3b(unsigned char *raw_data, float *cm_data)
{
	*raw_data = read_PSD3();
	*cm_data = raw2cm_PSD(*raw_data);
	print_c_sci1(*raw_data);
	return;
}


/*orcZT[茋ʓǂݎiPʂ̃f[^j*/
/*CbotƃTubot̗ǂݍ*/
void read_PSD2(float data[5])
{
unsigned char	i, raw_data[5];

	/*ZT[ǂݎ*/
	read_PSD(raw_data);
	/*Pʂɕϊ*/
	for(i = 0; i < 5; i++)
		data[i] = raw2cm_PSD(raw_data[i]);
	return;
}

/*orcZT[茋ʓǂݎif[^j*/
/*CbotƃTubot̗ǂݍ*/
void read_PSD(unsigned char data[4])
{
unsigned char	i;

	/*No.1TuCPUPSDf[^擾*/
	print_c_sci0('2');
	/*M҂*/
	i = read_c_sci0();
	/*TuR}hM*/
	print_c_sci0('1');

	for(i = 0; i < 3; i++)
	{
		data[i] = read_c_sci0();
	}

	/*CbotPSDf[^擾*/
	data[3] = read_PSD3();
	return;
}
/*********************************************************************/
/*********************************************************************/

/*vO}uM(8651B)ȂĂhstǂ*/
unsigned int read_add_clock(void)
{
	return(ITU1.TCNT);
}

/*vO}uM(8651B)̃vXP[[Zbg*/
void set_add_clock(unsigned char mode)
{
	/*1 kHz*/
	if(mode == 0)
	{
		PADR.BIT.B4 = 1;
		PADR.BIT.B5 = 0;
		PADR.BIT.B6 = 0;
	}
	/*100 Hz*/
	if(mode == 1)
	{
		PADR.BIT.B4 = 0;
		PADR.BIT.B5 = 1;
		PADR.BIT.B6 = 0;
	}
	/*10   Hz*/
	if(mode == 2)
	{
		PADR.BIT.B4 = 1;
		PADR.BIT.B5 = 1;
		PADR.BIT.B6 = 0;
	}
	/*1    Hz*/
	if(mode == 3)
	{
		PADR.BIT.B4 = 0;
		PADR.BIT.B5 = 0;
		PADR.BIT.B6 = 1;
	}
	/*0.1  Hz*/
	if(mode == 4)
	{
		PADR.BIT.B4 = 1;
		PADR.BIT.B5 = 0;
		PADR.BIT.B6 = 1;
	}
	/*0.01 Hz*/
	if(mode == 5)
	{
		PADR.BIT.B4 = 0;
		PADR.BIT.B5 = 1;
		PADR.BIT.B6 = 1;
	}

	/*ṽZbg*/
	ITU1.TCNT = 0;

	return;
}

/*********************************************************************/
/*********************************************************************/
/*uU[炷*/
/*time	F	K*/
/*tone	F	̍EEEKȉ*/
void beep(unsigned char time, unsigned char tone, unsigned char num)
{
unsigned char	i;
unsigned int	time2, tone_base, ii;


	time2 = 5 * time;
	tone_base = 100;

	for(i = 0; i < num; i++)
	{
		/*X bԃuU[炷*/
		for(ii = 0; ii < time2; ii++)
		{
			ITU0.TCNT = 0;

			P4DR.BIT.B7 = 1;
			while(ITU0.TCNT < tone_base * tone);

			P4DR.BIT.B7 = 0;
			while(ITU0.TCNT <  tone_base * tone * 2);
		}
		if(num > 1)
		{
			/**/
			for(ii = 0; ii < time2; ii++)
			{
				ITU0.TCNT = 0;
				while(ITU0.TCNT < tone_base * tone);
				while(ITU0.TCNT <  tone_base * tone * 2);
			}
		}
	}
}

/******************************************************************/
/**  T[~X^ZT[̓ǂݎ@@*****************************/
/******************************************************************/
unsigned int read_therm(void)
{
unsigned int ii;

	/*A/DRo[^@WX^ݒ*/
	/*ϊXgbv*/
	AD.CSR.BIT.ADST = 0;
	/*Pꃂ[h*/
	AD.CSR.BIT.SCAN = 0;
	/*vXe[g130*/
	AD.CSR.BIT.CKS = 0;
	/*3cĥݕϊ*/
	AD.CSR.BIT.CH = 4;
	/*ϊX^[g*/
	AD.CSR.BIT.ADST = 1;

	while(AD.CSR.BIT.ADST == 1);

	ii = AD.DRA / 128;
	return(ii);
}

