/************************************************************************/
/**  W6v5Cbot \tgivUpj                             **/
/**  2008/05/17 Jn                                               **/
/************************************************************************/
#include <3067F.H>
#include "w6v5c.h"

void motion_tracking1(struct SIO *sio, struct SWITCHES *switches
			   , unsigned int	mortion_arm[4096], unsigned int ptr_arm[128]);

void main(void)
{
unsigned char	i, ch;
unsigned int	mortion_arm[4096], ptr_arm[128];

unsigned int	ii;

struct SIO		sio;
struct SWITCHES switches;

	init_main();
	sio.interval_mode = 0;

	print_s_sci1(" ");
	print_s_sci1("Control PGM for W6 main CPU.");

	/*
	0	:	u샂[h
	1	:	[h1ij
	2	:	[h2ij
	3	:	[h3ij
	4	:	[h4ij
	5	:	[h5ij
	*/
	sio.run_mode = 0;
	sio.expose_time = 256;

	/**********************************************/
	/*𑖍s̏ʒuɃZbg*/
	move_head(90, 90, 90, 20);
	do{
		wait(100);
		i = check_status_servo();
	}while(i == 1);

	/**********************************************/
	print_s_sci1("Comunication loop is started.");
	/*
	*/

	/*dr̓d`FbN 6.5VŌx*/
	print_c_sci0('M');
	i = read_c_sci0();
	if(i < 167)		beep(100, 24, 1);/*dr؂*/
	else 			beep(20, 12, 2);/*OK*/

	/*qbT[{Mnee*/
	print_c_sci0('K');
	i = read_c_sci0();
	print_c_sci0(0);

	/*PSD ON*/
	PADR.BIT.B7 = 1;

	ch = 'A';
	while(1 == 1)
	{
		sio.command = read_c_sci1b();
		if(sio.command != 0)
		{
			/*Cbot̒ʐM*/
			i = sio_comm1(&sio, &switches, mortion_arm, ptr_arm);

			/*No.1 Tubotiړjbgj̒ʐM*/
			i = sio_comm2(&sio, &switches, mortion_arm, ptr_arm);
			
			/*No.2 Tubotijbgj̒ʐM*/
			i = sio_comm3(&sio, &switches, mortion_arm, ptr_arm);
		}

		if(sio.interval_mode == 1)
		{
			/*`FbN*/
			ii = ITU1.TCNT - sio.log_time0;
			if(ii > sio.log_interval)
			{
				sio.log_cds[ sio.log_datanum ]		= read_cds();

				for(i = 0; i < 10; i++)
					sio.log_thermo[ sio.log_datanum ]
						= sio.log_thermo[ sio.log_datanum ] + read_therm();

		beep(10, 12, 1);

				/*vJE^@I[o[t[`FbN 12/43200b */
				if(ITU1.TCNT >= 43200)
				{
					ITU1.TCNT = 0;
				}
				sio.log_time0 = ITU1.TCNT;
				sio.log_datanum++;
			}
		}

	}
}

/*********************************************************************/
/**     CCPUPC̒ʐM[`                                 **/
/*********************************************************************/
void motion_tracking1(struct SIO *sio, struct SWITCHES *switches
			   , unsigned int	mortion_arm[4096], unsigned int ptr_arm[128])
{
unsigned char	i, j, k, x, y, av, diff, cog_x, cog_y;
unsigned char	head_dirh, head_dirv, dirh, dirv, flg_move;
unsigned char	image_data1[2][128][128], image_data2[2][128][128];
unsigned int	ii, area;
unsigned int	expose_time;
float			a;


	expose_time = 256;
	head_dirh = 90;
	head_dirv = 80;

	flg_move = 1;

	print_s_sci1("head_dirh =");
	print_c_sci1(head_dirh);
	print_s_sci1("head_dirv =");
	print_c_sci1(head_dirv);

	move_head2(head_dirh, head_dirv, 90, 30);
	/*̓슮҂*/
	do{
		wait(100);
		i = check_status_servo();
	}while(i == 1);

	print_s_sci1("Adjusting exposure time...");
	k = adj_expose2(image_data1, &expose_time);
	print_s_sci1("Adjusting exposure time...finished.");

	while(1)
	{
		area = 0;
		i = 0;
		/*@Be@1@*/
		if(flg_move == 1)
		{
			beep(10, 12, 1);
			av = get_gbimage2(image_data1, i);
		}
		/*Io̎*/
		if(av < 80 || av > 200)
		{
			print_s_sci1("Adjusting exposure time...");
			av = adj_expose2(image_data1, &expose_time);
			print_s_sci1("Adjusting exposure time...finished.");
		}
		else
		{
			flg_move = 0;
			/*@Be@2@*/
			beep(10, 10, 1);
			j = get_gbimage2(image_data2, i);
			/***************************************/
			/*2̃C[Wr*/
			area = 0;
			for(y = 0; y < 128; y++)
			{
				for(x = 0; x < 128; x++)
				{
					if(image_data1[0][y][x] > image_data2[0][y][x])
					{
						diff = image_data1[0][y][x] - image_data2[0][y][x];
					}
					else
					{
						diff = image_data2[0][y][x] - image_data1[0][y][x];
					}

					if(diff > 20)
					{
						image_data1[1][y][x] = 1;
						area++;
					}
					else
					{
						image_data1[1][y][x] = 0;
					}
				}
			}
			/***************************************/
			/*dS߂*/
			if(area > 1)
			{
				area = area / 2;
				/*Y*/
				ii = 0;
				for(y = 0; y < 128; y++)
				{
					for(x = 0; x < 128; x++)
					{
						if(image_data1[1][y][x] == 1) ii++;
						if(ii >= area)
						{
							cog_y = y;
							y = 129;
							x = 129;
						}
					}
				}

				/*X*/
				ii = 0;
				for(x = 0; x < 128; x++)
				{
					for(y = 0; y < 128; y++)
					{
						if(image_data1[1][y][x] == 1) ii++;
						if(ii >= area)
						{
							cog_x = x;
							y = 129;
							x = 129;
						}
					}
				}
				print_s_sci1("cog_x =");
				print_c_sci1(cog_x);
				print_s_sci1("cog_y =");
				print_c_sci1(cog_y);
				/***************************************/
				/**/
				if(cog_x > 63)
				{
					cog_x = cog_x - 63;
					a = (float)0.3396 * (float)cog_x + (float)0.2318;
					dirh = (unsigned char) a;

					if(head_dirh > 25)
					{
						head_dirh = head_dirh - dirh;
					}
				}
				else
				{
					cog_x = 63 - cog_x;
					a = (float)0.3396 * (float)cog_x + (float)0.2318;
					dirh = (unsigned char) a;

					if(head_dirh < 155)
					{
						head_dirh = head_dirh + dirh;
					}
				}

				if(cog_y > 63)
				{
					cog_y = cog_y - 63;
					a = (float)0.3396 * (float)cog_y + (float)0.2318;
					dirv = (unsigned char) a;

					if(head_dirv > 45)
					{
						head_dirv = head_dirv - dirv;
					}
				}
				else
				{
					cog_y = 63 - cog_y;
					a = (float)0.3396 * (float)cog_y + (float)0.2318;
					dirv = (unsigned char) a;

					if(head_dirv < 140)
					{
						head_dirv = head_dirv + dirv;
					}
				}
				print_s_sci1("head_dirh =");
				print_c_sci1(head_dirh);
				print_s_sci1("head_dirv =");
				print_c_sci1(head_dirv);

				move_head2(head_dirh, head_dirv, 90, 12);
				/*̓슮҂*/
				do{
					wait(100);
					i = check_status_servo();
				}while(i == 1);

				flg_move = 1;
				/*̃tOĂȂ́AuPڎBevXLbv*/

			}/*dS܂*/
		}/*2摜r*/
	}
}
